MODULE FooM3Client2 EXPORTS Main;
IMPORT Fmt, Foo, Ilu, IluBasics, NameServer, ParseParams, RTMisc, Scan,
       Stdio, Thread, Wr;

<*FATAL Thread.Alerted, Wr.Failure*>

PROCEDURE FmtU (u: Foo.U; call: BOOLEAN): TEXT =
  PROCEDURE FmtO (o: Foo.O): TEXT =
    VAR u2: Foo.U;
    VAR t2: TEXT := "";
    BEGIN
      IF call THEN
        u2 := o.U_CSS_to_U(u, icss);
        t2 := " => " & FmtU(u2, FALSE);
      END (*if*);
      RETURN Ilu.SbhFromObject(o) & t2;
    END FmtO;
  BEGIN
    TYPECASE u OF
    | Foo.U_R (x) =>
        RETURN Fmt.F("R{%s, %s}", Fmt.Int(x.v.i), FmtCSS(x.v.css));
    | Foo.U_RO (x) =>
        IF x.v # NIL THEN
          RETURN Fmt.F("RO{%s, %s}", Fmt.Int(x.v.i), FmtCSS(x.v.css))
        ELSE
          RETURN "RO-NOT"
        END;
    | Foo.U_CSS (x) => RETURN FmtCSS(x.v);
    | Foo.U_O (x) => RETURN "O " & FmtO(x.v);
    | Foo.U_OO (x) =>
        IF x.v # NIL THEN
          RETURN "OO " & FmtO(x.v)
        ELSE
          RETURN "OO-NOT"
        END (*if*);
    | Foo.U_LongInt (x) =>
        RETURN
          Fmt.F(
            "LI[%s,%s]", Fmt.Int(x.v.high), Fmt.Unsigned(x.v.low, 10));
    ELSE
      RETURN "??";
    END (*typecase*);
  END FmtU;

PROCEDURE FmtCSS (css: Foo.CSS): TEXT =
  VAR ans := "<";
  BEGIN
    FOR i := 0 TO NUMBER(css^) - 1 DO
      IF i # 0 THEN ans := ans & ", " END;
      ans := ans & "`" & css[i] & "'";
    END (*for*);
    RETURN ans & ">";
  END FmtCSS;

VAR inst: TEXT;
VAR f: NameServer.Finding;
VAR n: INTEGER;
VAR icss: Foo.CSS;
VAR o: Foo.O;
VAR u: Foo.U;

BEGIN
  TRY
    ParseParams.BeginParsing(Stdio.stderr);
    inst := ParseParams.GetNext();
    n := ParseParams.NumParameters - ParseParams.NextParameter;
    icss := NEW(Foo.CSS, n);
    FOR i := 0 TO n - 1 DO icss[i] := ParseParams.GetNext() END;
    ParseParams.EndParsing();
    f := NameServer.FindObjectTypeOnce(Foo.ILU_Get_Type_O(NIL), inst);
    Wr.PutText(
      Stdio.stdout,
      Fmt.F("Instance %s has sbh %s, mstid %s.\n", inst, f.sbh, f.mstid));
    o := Foo.ILU_SBH_To_O(f.sbh, f.mstid);
    u := o.U_CSS_to_U(NEW(Foo.U_CSS, v := icss), icss);
    Wr.PutText(Stdio.stdout, "Got " & FmtU(u, TRUE) & "\n");
  EXCEPT
  | Scan.BadFormat =>
      Wr.PutText(Stdio.stderr, "Usage: FooM3Client SBH cs1 ... csn\n");
      RTMisc.Exit(1);
  | IluBasics.Failed (f) =>
      Wr.PutText(
        Stdio.stderr,
        "IluBasics.Failed(" & IluBasics.FullInfo(f) & ")\n");
      RTMisc.Exit(1);
  | Thread.Alerted =>
      Wr.PutText(Stdio.stderr, "Thread.Alerted\n");
      RTMisc.Exit(1);
  | Foo.E1 (v) =>
      Wr.PutText(Stdio.stderr, "Foo.E1(" & FmtU(v, TRUE) & ")\n");
      RTMisc.Exit(1);
  | Foo.E2 (v) =>
      Wr.PutText(Stdio.stderr, "Foo.E2(" & Fmt.Int(v) & ")\n");
      RTMisc.Exit(1);
  END (*try*);
END FooM3Client2.
