#!/import/misc/bin/python
#
# Copyright (c) 1991, 1992, 1993, 1994 Xerox Corporation.  All Rights Reserved.
#
# Unlimited use, reproduction, and distribution of this software is
# permitted.  Any copy of this software must include both the above
# copyright notice of Xerox Corporation and this paragraph.  Any
# distribution of this software must comply with all applicable United
# States export control laws.  This software is made available AS IS,
# and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
# INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
# PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
# THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
# CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
# XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
# $Id: rwho2PyClient.py,v 1.4 1994/10/14 00:32:06 severson Exp $
#

import sys
import ilu
import rwho2

argc = len(sys.argv)
if argc < 2:
    print 'usage:', sys.argv[0], '<sbh-machine1> [ <sbh-machine2> ... ]'
    sys.exit(1)

def printUser(user):
    print '  ', user.Name()

def enumerateUsers(userSeq):
    for i in range(0, len(userSeq)):
	printUser(userSeq[i])

def doForMachine(sbh):
    m = ilu.ObjectOfSBH(rwho2.machine, sbh)
    print '==', m.Name(), ' (server started', m.StartTime() + ')'
    print
    print 'Status: ', m.Status()
    print
    users = m.ListUsers()
    print 'Users at ' + users['time'] + ':'
    enumerateUsers(users['users'])
    print

for i in range(1, argc):
    sbh = sys.argv[i]
    try:
	doForMachine(sbh)
    except:
	print 'got exception talking to machine', sbh
