(* IluGc.m3 *)
(* Copyright (c) 1991, 1992, 1993 Xerox Corporation.  All Rights
   Reserved.

   Unlimited use, reproduction, and distribution of this software is
   permitted.  Any copy of this software must include both the above
   copyright notice of Xerox Corporation and this paragraph.  Any
   distribution of this software must comply with all applicable United
   States export control laws.  This software is made available AS IS,
   and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
   INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
   NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY
   FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY
   DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE)
   OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGES. *)
(* $Id: IluGc.m3,v 1.3 1994/11/04 05:22:16 spreitze Exp $ *)
(* Edited by Mike Spreitzer November 3, 1994 9:22 pm PST *)

MODULE IluGc EXPORTS IluF;
IMPORT Ilu, IluBasics, IluF, IluKernel;
FROM IluBasics IMPORT Failed, Failure;

EXCEPTION
  CantHappen;
  <*FATAL CantHappen*>

TYPE
  Pinger = Ilu.Object OBJECT
           OVERRIDES
             ILU_Get_Server := GetServer;
             ILU_Get_Type   := GetType;
             ILU_Qua_Type   := QuaType
           END;

VAR s: Ilu.TrueServer;
VAR cc: Ilu.ObjectType;
VAR p: Pinger;
VAR kp: IluKernel.Object;

PROCEDURE GetServer (<*UNUSED*> self: Pinger): Ilu.Server =
  BEGIN
    RETURN s
  END GetServer;

PROCEDURE GetType (<*UNUSED*> self: Pinger): Ilu.ObjectType =
  BEGIN
    RETURN cc
  END GetType;

PROCEDURE QuaType (self: Pinger; ot: Ilu.ObjectType): Ilu.Object =
  BEGIN
    IF ot = cc THEN RETURN self ELSE RETURN NIL END;
  END QuaType;

VAR fDump: Failure;

PROCEDURE StartGcClientSide () =
  BEGIN
    s := NEW(Ilu.TrueServer);
    p := NEW(Pinger, ilu_is_surrogate := FALSE);
    TRY
      EVAL Ilu.InitTrueServer(s);
      Ilu.Export_Server(s, NEW(Ilu.SunRpc2), NEW(Ilu.TCP));
      cc := IluKernel.ilu_GetGcCallbackClass();
      kp := IluF.KOfO(p);
      IluKernel.ilu_ExitServer(s.ks, cc);
    EXCEPT
      Failed (f) => fDump := f; RAISE CantHappen
    END;
    IF kp # NIL THEN
      IluKernel.ilu_SetGcClient(kp);
    ELSE
      RAISE CantHappen
    END (*if*);
  END StartGcClientSide;

BEGIN
END IluGc.
